// PiNGHUD v0.92
// by {FSC} Rayn -PTT-
// rayn@planet-tribes.com
// Idea by: [FTM] Tequila
// --------------------------------------------------------------------------
// 		              VISIT WWW.PLANET-TRIBES.COM
// 			 The Premier Tribes Resource On The Web
// --------------------------------------------------------------------------
// Tequila requested a small HUD that would display your current ping so I
// whipped this up.  It updates every 3 seconds, if it were any more it would
// interfere with your ping.  The ping shown is not exact but very close.
// Send me your feedback or feel free to modify as needed, drop me a line if you
// do I'd like to see.  
//
//	 * Feedback/Bug Reports/Love Letters to: rayn@planet-tribes.com *
//
// ---------------------------------------------------------------------------
// QUICK THANKS:
// Go out to the entire Scripting Community for inspiration and knowledge. Special
// shoutouts to Presto and Writer whose scripts keep me from reinventing the wheel
// over and over.  Good work guys, the stuff you create is incredible.
// ---------------------------------------------------------------------------
// INSTALL NOTES
// Requires:
//		Presto Pack v0.93 or better
//		Writers Scripts (most recent versions included)
// Add this line to your AUTOEXEC.CS somewhere after Include("Presto\\Install.cs"); :
//	Include("rayn\\pingHUD.cs");
//	
// ---------------------------------------------------------------------------
// PING HUD PREFERENCES 
// Set to customize and configure HUD

// Use this line to place PingHUD at an absolute position

$phud::position = "848 0 52 18";  
$phud::updateInterval = "15.0";

// ---------------------------------------------------------------------------
//
// ----------------------------- BEWARE OF CODE -------------------------------

Include("writer\\Schedule.cs");
Include("writer\\ping.cs");
Include("presto\\HUD.cs");
Include("presto\\event.cs");
$phud::debugMode = false;
$phud::initialized = false;

Event::Attach(eventConnected,"phud::init",initPHUD);

function phud::init() 
{
     Ping::Reset();
     deleteVariables("$Getping::*");  
     $phud::check = true;
     $phud::pingText = "0";

     if (!HUD::Exists(pingdhud)) 
     HUD::New("pingdhud","phud::updatePingHUD", $phud::position);
     HUD::Display("pingdhud");
     phud::checkPing();     
}

function phud::toggle()
{
    $phud::check = !phud::check;    
    HUD::ToggleDisplay(pingdhud);	
}

function phud::updatePingHUD()
{
    HUD::SetText("pingdhud",$phud::pingText);
    HUD::Display("pingdhud");
}

function phud::computePing()
{
  deleteVariables("$Getping::*");
  Ping::Get(quiet);
  %p = ($PingDelay * 1000);
  $phud::currentPing = floor(%p);
  if ($phud::debugmode)
	ECHO ($phud::currentPing);     
}

function phud::checkPing()
{
  if ($phud::debugmode)
	ECHO ("CHECKING PING");
  phud::computePing();
  $phud::pingText = phud::pickGfx();	
  $phud::pingText = $phud::pingText @ $phud::currentPing;
  HUD::Update(pingdhud); 
  Schedule::Add("phud::checkPing();",$phud::updateInterval);
}

function phud::pickGfx()
{
  if ($phud::currentPing <= $Pref::ConnectionGoodPing)
     %txt = "<jl><f2><B0,2:ping_green.bmp><l3>";
  else if ($phud::currentPing < $Pref::ConnectionPoorPing)
     %txt = "<jl><f2><B0,2:ping_yellow.bmp><l3>";
  else 
     %txt = "<jl><f2><B0,2:ping_red.bmp><l3>";

  return %txt;
}

